import time as tm
import serial
import keyboard
import threading
import signal, sys
from pynput.keyboard import Key, Listener
import csv

ser = serial.Serial(
    port='COM9',
    baudrate=9600,
    bytesize=8,
    parity="N",
    stopbits=1,
    #write_timeout = 1,
    timeout=0.050)

first_time=True
heating=True
    
def sigint_handler(signal, frame):
    data_input()
    main()
    sys.exit(0)

signal.signal(signal.SIGINT, sigint_handler)

class TimeOver(Exception): pass


def kyta(set_point1, set_point2, temp, time):
    global heating
    
    if len(temp)>0 and len(time)>0:
        ser.write(bytes(set_point1.encode("utf-8")+set_point2.encode("utf-8")))

def write_csv(data):
    global first_time
    global heating
    
    mcu_time=data[data.find("time: ")+6:data.find("; t1")]
    #termopaar1
    temp1=data[data.find("t1: ")+4:data.find(", t1_pid")]
    pid1=data[data.find("t1_pid: ")+8:data.find(", t1_target")]
    target1=data[data.find("t1_target: ")+11:data.find("; t2")]


    #termopaar2
    temp2=data[data.find("t2: ")+4:data.find(", t2_pid")]
    pid2=data[data.find("t2_pid: ")+8:data.find(", t2_target")]
    target2=data[data.find("t2_target: ")+11:data.find("; p1")]

    #peltier
    temp3=data[data.find("p1: ")+4:data.find("p_pid: ")]
    pid3=data[data.find("p_pid: ")+7:]

    #viimane katse
    if len(mcu_time)>0:
        if float(mcu_time)/60 >= 0.0 and float(mcu_time)/60 < 100.0:
            kyta("50.0 ","50.0",temp1,mcu_time)
        if float(mcu_time)/60 >= 1.0 and float(mcu_time)/60 < 8.0:
            kyta("100.0 ","100.0",temp1,mcu_time)
        if float(mcu_time)/60 >= 8.0 and float(mcu_time)/60 < 14.0:
            kyta("150.0 ","150.0",temp1,mcu_time)
        if float(mcu_time)/60 >= 14.0 and float(mcu_time)/60 < 18.0:
            kyta("50.0 ","50.0",temp1,mcu_time)
        if float(mcu_time)/60 >= 2300.0:
            raise TimeOver
        
    with open("test_data1.csv","a",newline='', encoding='utf-8') as f:
        writer = csv.writer(f, delimiter=";")
        if first_time==True:
            writer.writerow(["PC time","time","t1","t1 PID","t1 target", "t2", "t2 PID", "t2 target","peltier temp", "peltier PID", "kp=0.029; kd=0.0009"])
            first_time=False
                
        t=tm.time()
        writer.writerow([t, mcu_time, temp1, pid1, target1,temp2, pid2, target2, temp3, pid3])   #, pid3[pid3.find("p_pid: ")+7:]
    

def main():
    try: 
        while True:
            data_in = ser.readline()
            print(data_in)
            new_str=str(data_in.decode("utf-8"))
            substr=""
            
            if new_str.count("time")==2:
                res = [i for i in range(len(new_str)) if new_str.startswith("time", i)]
                substr=new_str[res[1]:]
                new_str=new_str[0:len(new_str)-len(substr)]


            if len(substr)>0:
                write_csv(new_str)
                write_csv(substr)
            else:
                write_csv(new_str)
    except TimeOver:
        print("aeg on täis.")
        pass
        
def data_input():
    while 1:
        print("1 - element on, 0 - element off\n")
        k1_temp=""
        k2_temp=""
        pelt_temp=""

        kytte1=input("temp:")
        ser.write(bytes(kytte1.encode("utf-8")))
        break
    main()
        
#data_input()
main()

    
    
    

            
        
        
    
    

